/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2022 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "i2c.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include <stdio.h>
#include <math.h>
#include "TEA5767Radio.h"
#include "ssd1306.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
char printData[50];
double freq = 98.9;
short int state0 =1, state1=1;
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
void printFreq() {
	ssd1306_SetCursor(35, 36);
	ssd1306_WriteString("     ", Font_11x18, White);

	ssd1306_SetCursor(20, 0);
	ssd1306_WriteString("FM RADIO", Font_11x18, White);
	ssd1306_SetCursor(40, 16);
	ssd1306_WriteString("freq:", Font_11x18, White);
	if (freq >= 100) {
		ssd1306_SetCursor(35, 36);
	} else {
		ssd1306_SetCursor(40, 36);
	}
	sprintf(printData, "%3.1f", freq); //enable full c++ to make it work!
	ssd1306_WriteString(printData, Font_11x18, White);

	ssd1306_SetCursor(0, 36);
	ssd1306_WriteString("<", Font_11x18, White);
	ssd1306_SetCursor(116, 36);
	ssd1306_WriteString(">", Font_11x18, White);
	ssd1306_UpdateScreen();
}

void printFreqDown() {
	ssd1306_SetCursor(0, 36);
	ssd1306_WriteString("<", Font_11x18, Black);
	ssd1306_UpdateScreen();
	HAL_Delay(20);
	printFreq();
}

void printFreqUp() {
	ssd1306_SetCursor(116, 36);
	ssd1306_WriteString(">", Font_11x18, Black);
	ssd1306_UpdateScreen();
	HAL_Delay(50);
	printFreq();
}

void setFreq() {
	if (freq > 108.0) freq = 87.0;
		
	if (freq < 87.0) freq = 108.0;
		
	setFrequency(freq);
}

int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_I2C1_Init();
  /* USER CODE BEGIN 2 */
   ssd1306_Init();
	 setFreq();
	 printFreq();
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
		  if(HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_9)==LOW) {  
	      HAL_Delay(10); 
	      if(HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_9)==LOW) state0=0, HAL_Delay(10);			 
   }
		  if( HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_9)==HIGH && state0==0) {
			freq -= 0.1;
			setFreq();
			printFreqDown();
			HAL_Delay(20); 
			state0=1; 	

		}
		if(HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_10)==LOW) {  
	      HAL_Delay(10); 
	      if(HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_10)==LOW) state1=0, HAL_Delay(10);			 
   }
		  if( HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_10)==HIGH && state1==0) {
			freq += 0.1;
			setFreq();
			printFreqDown();
			HAL_Delay(20); 
			state1=1; 	

		}	
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage 
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 12;
  RCC_OscInitStruct.PLL.PLLN = 96;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_3) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
